Bug 1075822 - Review Request: openstack-marconi - OpenStack Message Queuing Service
Review Request: openstack-marconi - OpenStack Message Queuing Service
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Haïkel Guémar
Fedora Extras Quality Assurance
Depends On:
  Show dependency treegraph
Reported: 2014-03-12 18:36 EDT by Jon Bernard
Modified: 2014-09-02 04:14 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2014-09-02 04:14:54 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
karlthered: fedora‑review+
petersen: fedora‑cvs+

Attachments (Terms of Use)

  None (edit)
Description Jon Bernard 2014-03-12 18:36:18 EDT
Spec URL: https://gist.githubusercontent.com/jbernard/8602750/raw/fb269aacb9df48656beb8b5ef052f426f4a0150c/openstack-marconi.spec

SRPM URL: https://gist.githubusercontent.com/jbernard/8602750/raw/fa7fb95745e12f5c4d014a6ecd8f67fd081b78cb/openstack-marconi-2014.1.b2.dev57.gd8341ad-1.fc20.src.rpm


Marconi is a messaging and notifications service for the OpenStack product portfolio, supporting point-to-point, producer-consumer, publisher-subscriber models. Marconi is designed to perform and scale in a multi-tenant environment. 

Fedora Account System Username: jbernard
Comment 1 Stanislav Ochotnicky 2014-03-14 05:15:32 EDT
Few notes before Haïkel gets to this:
 1. Version is incorrect. Look at naming guidelines[1]. This seems like post-release version situation. I'd strongly suggest packaging upstream releases whenever possible
 2. Source0 URL doesn't exist (it seems almost as a joke...)
 3. There is no changelog
 4. Apache 2.0 requires full LICENSE text to be distributed with all binary/source packages. You have to include it even if upstream doesn't (but that should be fixed upstream eventually because they cause all redistributors to fail their own license...)
 5. While you are at it packaging ChangeLog would be nice as well

[1] https://fedoraproject.org/wiki/Packaging:NamingGuidelines?rd=Packaging/NamingGuidelines#Version_Tag
Comment 2 Haïkel Guémar 2014-03-14 05:31:12 EDT
Thanks Stanislav :)
I'll add few more points: 
* use the systemd scriptlets
* did you check with RDO packagers to coordinate with them ?
Comment 3 Eduardo Echeverria 2014-03-15 18:04:14 EDT
The unversioned macros, %{__python}, %{python_sitelib}, and %{python_sitearch} are deprecated. Please use the correct macros https://fedoraproject.org/wiki/Packaging:Python#Macros
Comment 4 Flavio Percoco 2014-03-17 05:24:55 EDT
Hey, just a quick note. Please, remember to set the needinfo on the interested person so he/she gets notified.
Comment 5 Jon Bernard 2014-03-17 18:38:18 EDT
Thanks for all of the input.  I have made all of the suggested changes:

Spec URL: https://gist.github.com/jbernard/8602750#file-openstack-marconi-spec

SRPM URL: https://gist.github.com/jbernard/8602750#file-openstack-marconi-2014-1-b3-fc20-src-rpm

I have submitted a patch upstream to include the full license content, I should wait for the new build once it's merged, or just put it into the package now?

For the RDO packagers, what is the correct way to make this packaging known to them?

Thanks for all of the input!
Comment 6 Haïkel Guémar 2014-03-20 04:21:01 EDT
I'll start reviewing and testing your package but I can't approve it until you've been sponsored into the packager group.
To move forward into the sponsoring process, I'll ask you to do two informal reviews and link them back here. Avoid FE-NEEDSPONSOR tickets as I usually finish the reviews, it will get me into a recursive loop ;)
http://fedoraproject.org/PackageReviewStatus/NEW.html <= list of review tickets
Comment 7 Jon Bernard 2014-03-25 13:49:44 EDT
Here is one for Mino: https://bugzilla.redhat.com/show_bug.cgi?id=1078960#c2
Comment 8 Haïkel Guémar 2014-03-27 06:33:21 EDT
The build fails in mock since you have a missing BR on systemd (it brings all the systemd rpm macros like %{_unitdir})

BuildRequires: systemd
Comment 9 Jon Bernard 2014-03-27 09:55:41 EDT
Can you tell me the exact command you're running?  I would like to reproduce this failure here.
Comment 10 Haïkel Guémar 2014-03-27 09:59:47 EDT
mock -r fedora-rawhide-x86_64 openstack-marconi-2014.1.b2.dev57.gd8341ad-1.fc20.src.rpm

It doesn't fail on a standard Fedora install, only in mock chroot but it's a mandatory point for the review.
The BR is also documented in the guidelines:
Comment 12 Haïkel Guémar 2014-04-07 04:32:28 EDT
FYI, we discussed with Jon on irc and by emails.
Basically, until we move forward with the sponsorship process, we can't finish this review. He still need to come up with a good informal review so sponsors may assess his knowledge about RPM packaging and Fedora guidelines.
As for the commitment part, I am affirmative that Jon will be committed to maintain properly this package.

I'm pretty confident that the review will go well from my preliminary reviews.
Comment 13 Matthias Runge 2014-04-11 05:01:03 EDT
Ugh, I just saw, you're inserting a hard coded user id. Please don't do that, unless really necessary, and I don't see that in this case.

Wenn iterating in review, please add a comment to the changelog and increase the release, as it makes it easier for the reviewer to follow the changes.

Regarding sponsoring, I'll take care of that. Jon will become co-maintainer of glance, too.
Comment 14 Jon Bernard 2014-04-11 10:30:37 EDT
Yes, that was the one thing that bothered me - it seems both the glance and nova packages do this same thing so I wasn't sure if there was some technical reason.  I will fix this up, and update the glance packages as well.  Thanks for the input.
Comment 15 Jon Bernard 2014-04-11 10:31:19 EDT
I posted some review comments on the python-dicttoxml package: https://bugzilla.redhat.com/show_bug.cgi?id=1084199
Comment 17 Haïkel Guémar 2014-04-14 15:23:23 EDT
Release: b3%{dist} 
Please fix the release tag according the guidelines

As soon as we clear the sponsoring (you still have to provide another informal review), we'll move forward.
Comment 18 Jon Bernard 2014-04-14 18:09:08 EDT
This might count as an informal review: https://bugzilla.redhat.com/show_bug.cgi?id=1087053
Comment 20 Haïkel Guémar 2014-04-15 08:13:09 EDT
Since you improved the previous review and that Mattias offered to take you as a co-maintainer for glance, I'll sponsor you.
Remember that as your sponsor, you could always ping me for help or packaging questions until you become either a sponsor yourself or provenpackager.

Let's move on.
Comment 21 Matthias Runge 2014-04-15 13:06:45 EDT
Haikel, nope, I'm afraid, I'm not the maintainer for glance, but that shouldn't prevent you from sponsoring Jon.
Comment 22 Haïkel Guémar 2014-04-15 13:20:26 EDT
@Matthias: no problem, we had a little chat with Jon today, and I will be sponsoring him anyway :)
Comment 23 Haïkel Guémar 2014-04-16 15:46:33 EDT
Few things:
* it is common to have the %files section the last and scriptlets before, though it's not a blocker, please fix it.
* for the record, you'll be co-maintainer of openstack-glance with Flavio and not Mattias

I finished reviewing the package, fix the %files section and it's all good for me :)
Comment 25 Haïkel Guémar 2014-04-16 16:47:33 EDT
Thanks, congratulations for joining the Fedora Packager group :)

I hereby approve this package into Fedora Packages Collection, please file a scm request and feel free to ping me if you need help.


Package Review

[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed

===== MUST items =====

[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)", "Unknown or generated", "*No copyright* Apache (v2.0)".
     3 files have unknown license. Detailed output of licensecheck in
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /etc/logrotate.d
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

[x]: Python eggs must not download any dependencies during the build process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.

Checking: openstack-marconi-2014.1.b3-1.fc20.noarch.rpm
openstack-marconi.noarch: W: spelling-error %description -l en_US multi -> mulch, mufti
openstack-marconi.noarch: W: non-standard-gid /etc/marconi/logging.conf marconi
openstack-marconi.noarch: E: non-readable /etc/marconi/logging.conf 0640L
openstack-marconi.noarch: W: non-standard-gid /etc/marconi/marconi.conf marconi
openstack-marconi.noarch: E: non-readable /etc/marconi/marconi.conf 0640L
openstack-marconi.noarch: W: non-standard-gid /etc/logrotate.d/openstack-marconi marconi
openstack-marconi.noarch: W: non-standard-uid /var/log/marconi marconi
openstack-marconi.noarch: W: non-standard-gid /var/log/marconi marconi
openstack-marconi.noarch: E: non-standard-dir-perm /var/log/marconi 0750L
openstack-marconi.noarch: W: no-manual-page-for-binary marconi-server
openstack-marconi.src: W: spelling-error %description -l en_US multi -> mulch, mufti
2 packages and 0 specfiles checked; 3 errors, 8 warnings.

Rpmlint (installed packages)
# rpmlint openstack-marconi
openstack-marconi.noarch: W: spelling-error %description -l en_US multi -> mulch, mufti
openstack-marconi.noarch: W: non-standard-gid /etc/marconi/logging.conf marconi
openstack-marconi.noarch: E: non-readable /etc/marconi/logging.conf 0640L
openstack-marconi.noarch: W: non-standard-gid /etc/marconi/marconi.conf marconi
openstack-marconi.noarch: E: non-readable /etc/marconi/marconi.conf 0640L
openstack-marconi.noarch: W: non-standard-gid /etc/logrotate.d/openstack-marconi marconi
openstack-marconi.noarch: W: non-standard-uid /var/log/marconi marconi
openstack-marconi.noarch: W: non-standard-gid /var/log/marconi marconi
openstack-marconi.noarch: E: non-standard-dir-perm /var/log/marconi 0750L
openstack-marconi.noarch: W: no-manual-page-for-binary marconi-server
1 packages and 0 specfiles checked; 3 errors, 7 warnings.
# echo 'rpmlint-done:'

openstack-marconi (rpmlib, GLIBC filtered):


Source checksums
https://launchpad.net/marconi/icehouse/icehouse-3/+download/marconi-2014.1.b3.tar.gz :
  CHECKSUM(SHA256) this package     : 190c3ecf776b87e7d3efc9b266f581c336841db7724e93098af6590729d0a980
  CHECKSUM(SHA256) upstream package : 190c3ecf776b87e7d3efc9b266f581c336841db7724e93098af6590729d0a980
Comment 26 Jon Bernard 2014-04-16 17:20:24 EDT
New Package SCM Request
Package Name: openstack-marconi
Short Description: OpenStack Message Queuing Service
Owners: jbernard flaper87
Branches: el6-icehouse epel7
Comment 27 Jens Petersen 2014-04-17 01:22:30 EDT
Git done (by process-git-requests).

Note there is no such branch as el6-icehouse AFAIK,
so I created a normal EL-6 branch.
If you need a f20 branch, please make a Package Change Request later.
Comment 28 Jon Bernard 2014-05-20 16:31:50 EDT
Haïkel, we can close this bug now?
Comment 29 Haïkel Guémar 2014-05-20 17:00:10 EDT
You should have told bodhi to close this ticket for you. Anyway as soon as it lands in the repositories, you could close the ticket with resolution: next release.
Comment 30 Haïkel Guémar 2014-09-02 04:14:54 EDT
Package has been imported, closing ticket.

Note You need to log in before you can comment on or make changes to this bug.